package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScIxrMngmRepository;
import com.its.op.dto.its.scrs.TbScIxrMngmDto;
import com.its.op.entity.its.scrs.TbScIxrMngm;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScIxrMngmService {

    private final TbScIxrMngmRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScIxrMngm requireOne(String ixrId) throws NoSuchElementException {
        Optional<TbScIxrMngm> info = this.repo.findById(ixrId);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + ixrId);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrMngmDto> findAll() {
        List<TbScIxrMngmDto> result = new ArrayList<>();
        List<TbScIxrMngm> data = this.repo.findAll();
        for (TbScIxrMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrMngmDto> findAllList() {
        List<TbScIxrMngmDto> result = new ArrayList<>();
        List<TbScIxrMngm> data = this.repo.findAllList();
        for (TbScIxrMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScIxrMngmDto findById(String ixrId) {
        TbScIxrMngm entity = requireOne(ixrId);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbScIxrMngmDto updateById(String ixrId, TbScIxrMngmDto.TbScIxrMngmUpdReq req) {
        TbScIxrMngm entity = requireOne(ixrId);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScIxrMngmDto> mergeInfoList(List<TbScIxrMngmDto.TbScIxrMngmUpdReq> reqList) {
        List<TbScIxrMngmDto> result = new ArrayList<>();
        for (TbScIxrMngmDto.TbScIxrMngmUpdReq req : reqList) {
            TbScIxrMngm obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScIxrMngmDto mergeInfo(TbScIxrMngmDto.TbScIxrMngmUpdReq req) {
        TbScIxrMngm obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScIxrMngmDto deleteById(String ixrId) {
        TbScIxrMngm entity = requireOne(ixrId);
        this.repo.deleteById(ixrId);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScIxrMngmDto> deleteByIds(List<String> ids) {
        List<TbScIxrMngmDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbScIxrMngm> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
